ServletRegistration (Servlet 4.0 API Documentation - Apache Tomcat 9.0.111)
Description: declaration: package: javax.servlet, interface: ServletRegistration

# Interface ServletRegistration

All Superinterfaces:
  `Registration`

All Known Subinterfaces:
  `ServletRegistration.Dynamic`

public interface ServletRegistration extends Registration
Interface through which a Servlet may be further configured.

Since:
  Servlet 3.0

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Interface
  Description
  `static interface`
  `ServletRegistration.Dynamic`
  Interface through which a Servlet registered via one of the addServlet methods on ServletContext may be further configured.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Set<String>`
  `addMapping(String... urlPatterns)`
  Adds a servlet mapping with the given URL patterns for the Servlet represented by this ServletRegistration.
  `Collection<String>`
  `getMappings()`
  Gets the currently available mappings of the Servlet represented by this ServletRegistration.
  `String`
  `getRunAsRole()`
  Obtain the name of the user / group under which the Servlet has been configured to run.

  ### Methods inherited from interface Registration

  `getClassName, getInitParameter, getInitParameters, getName, setInitParameter, setInitParameters`

- ## Method Details

  - ### addMapping

    Set<String> addMapping(String... urlPatterns)
    Adds a servlet mapping with the given URL patterns for the Servlet represented by this ServletRegistration. If any of the specified URL patterns are already mapped to a different Servlet, no updates will be performed. If this method is called multiple times, each successive call adds to the effects of the former. The returned set is not backed by the ServletRegistration object, so changes in the returned set are not reflected in the ServletRegistration object, and vice-versa.
    Parameters:
      `urlPatterns` - The URL patterns that this Servlet should be mapped to
    Returns:
      the (possibly empty) Set of URL patterns that are already mapped to a different Servlet
    Throws:
      `IllegalArgumentException` - if urlPattern is null or empty
      `IllegalStateException` - if the associated ServletContext has already been initialised

  - ### getMappings

    Collection<String> getMappings()
    Gets the currently available mappings of the Servlet represented by this ServletRegistration. If permitted, any changes to the returned Collection must not affect this ServletRegistration.
    Returns:
      a (possibly empty) Collection of the currently available mappings of the Servlet represented by this ServletRegistration

  - ### getRunAsRole

    String getRunAsRole()
    Obtain the name of the user / group under which the Servlet has been configured to run.
    Returns:
      the name of the user / group or `null` if none has been specified